Imports GrapeCity.ActiveReports 
Imports GrapeCity.ActiveReports.Document
Imports GrapeCity.ActiveReports.Document.Section

Public Class SectionReport1

    Public Doc As SectionDocument
    Private docs_count As Integer = 0
    Private counter As Integer = 0

    Private Sub SectionReport1_FetchData(sender As System.Object, eArgs As GrapeCity.ActiveReports.SectionReport.FetchEventArgs) Handles MyBase.FetchData
        counter += 1
        If counter <= 3000 Then
            eArgs.EOF = False
        Else
            eArgs.EOF = True
        End If
    End Sub

    Private Sub detail_Format(sender As System.Object, e As System.EventArgs) Handles detail.Format
        textBox1.Text = "Record: " & counter.ToString()
    End Sub

    Private Sub SectionReport1_PageEnd(sender As System.Object, e As System.EventArgs) Handles MyBase.PageEnd
        If Me.Document.Pages.Count > 52 Then
            Doc = New SectionDocument()
            For j As Integer = 0 To 49
                Doc.Pages.Add(TryCast(Me.Document.Pages(0).Clone(), Page))
                Me.Document.Pages.RemoveAt(0)
            Next
            Doc.Save(System.Windows.Forms.Application.StartupPath & "\doc_" & docs_count.ToString() & ".ddd")
            docs_count += 1
            Doc.Pages.Clear()
            Doc.Dispose()
        End If
    End Sub

    Private Sub SectionReport1_ReportEnd(sender As System.Object, e As System.EventArgs) Handles MyBase.ReportEnd
        Dim DocTemp As New SectionDocument()
        Doc = New SectionDocument()
        For j As Integer = 0 To docs_count - 1
            DocTemp.Load(System.Windows.Forms.Application.StartupPath & "\doc_" & j.ToString() & ".ddd")
            Doc.Pages.AddRange(TryCast(DocTemp.Pages.Clone(), PagesCollection))
            DocTemp.Pages.Clear()
            DocTemp.Dispose()
        Next
        For Each p As Page In Me.Document.Pages
            Doc.Pages.Add(TryCast(p.Clone(), Page))
        Next
        Me.Document.Pages.Clear()
        Me.Document.Pages.AddRange(Doc.Pages)
    End Sub
End Class
